import os

directory = os.getcwd()

TICK_INTERVAL = 60

def add_track(track_name, seconds, number, volume):
    ticks = int(seconds)*20
    with open("change_track.mcfunction", 'r') as reader:
        lines = reader.readlines()

    with open("change_track.mcfunction", 'w') as writer:
        for i in range(0, (len(lines))):
            if (lines[i] == "#trackTime\n"):
                new_line = "scoreboard players set @s[scores={musicSet=" + number + "}] musicRemain " + str(ticks  + 20)
                writer.write(new_line)
                writer.write("\n#trackTime\n")
            elif (lines[i] == "#playTrack\n"):
                new_line = "playsound custom." + track_name + " record @s[scores={musicSet=" + number + "}] ~ ~ ~ " + volume + " 1 1"
                writer.write(new_line)
                writer.write("\n#playTrack\n")
            else:
                writer.write(lines[i])

def add_fade(track_name, seconds, number, volume):
    ticks = int(seconds)*20
    clipNum = int(ticks / TICK_INTERVAL)

    print(str(clipNum))

    with open("fade_out/attempt.mcfunction", 'r') as reader:
        lines = reader.readlines()

    with open("fade_out/attempt.mcfunction", 'w') as writer:
        for i in range(0, (len(lines))):
            if (lines[i] == "#newFade\n"):
                heading = track_name.replace("_"," ")
                writer.write("#" + (heading).title() + "\n")
                for j in range(1, clipNum+1):
                    line_1 = "execute if score @s musicTrack matches " + number + " if score @s musicTime matches " + str(j*TICK_INTERVAL) + " run function cc:music/fade_out/stop_music"
                    line_2 = "execute if score @s musicTrack matches " + number + " if score @s musicTime matches " + str(j*TICK_INTERVAL) + " run playsound custom." + track_name + "_fo_" + str(j) + " record @s ~ ~ ~ " + volume + " 1"
                    writer.write(line_1 + "\n")
                    writer.write(line_2 + "\n")
                writer.write("\n#newFade\n")
            else:
                writer.write(lines[i])

def read_song_info(info,num):
    length_index = info.find(" | Length:")
    segment_index = info.find(" | Segments:")

    name = info[6:length_index]
    length = info[length_index+11:segment_index]
    add_track(name, length, str(num), "1")
    add_fade(name, length, str(num), "1")

# while(True):
#     track_name = input("Track Name: ")
#     seconds = input("Seconds: ")
#     number = input("Track Number: ")
#     volume = input("Volume: ")
#     add_track(track_name, seconds, number, volume)
#     add_fade(track_name, seconds, number, volume)

#     k = input("Type EXIT to exit OR enter to continue: ")

#     if(k == "EXIT"):
#         break
track_num = 1

while(True):
    
    song_input = input("Song Input:")

    if(song_input == ""):
        break

    read_song_info(song_input,track_num)
    track_num += 1

k = input("Press ENTER to EXIT")